/************************************************************************
 *
 * Copyright (C) 2009-2018 IRCAD France
 * Copyright (C) 2012-2018 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

/// The namespace fwGui contains the base interface for IHM services.
#pragma once

namespace fwGui
{

/// The namespace fwGui::builder contains the base interface for GUI elements builder.
namespace builder
{
} // namespace builder

/// The namespace fwGui::container contains the base interface for GUI containers (toolbar, menu, menuBar...).
namespace container
{
} // namespace container

/// The namespace fwGui::dialog contains the base interface for GUI dialog elements.
namespace dialog
{
} // namespace dialog

/// Contains fwGui::factory utilities
namespace factory
{
} // namespace factory

/// The namespace fwGui::layoutManager contains the base interface of managers used to handle the GUI layouts available
/// in Sight.
namespace layoutManager
{
} // namespace layoutManager

/// The namespace fwGui::registrar contains the classes of service management of GUI elements (Menu, View, ToolBar).
namespace registrar
{
} // namespace registrar

///Contains fwGui::registry details
namespace registry
{
} // namespace registry

} // namespace fwGui
